.intel_syntax noprefix

.text
.global maksimum

# int maksimum(int a, int b);
# eax          edi    esi
maksimum:
	enter 0,0

	#poredimo sadrzaje registara edi i esi
	#cmp intrukcija vrsi oduzimanje ali ne upisuje nigde rezultat
	#primene operacije, vec samo azurira flegove u rflags registru
	cmp edi, esi

	#jng instrukcija vrsi skok na adresu koja je data kao operand
	#ukoliko je rezultat prethodnog poredjenja vece ili jednako
	#(ako je 1. operand cmp instrukcije je veci ili jednak od 2. operanda)
	jge prvi_max

	#ukoliko prethodni uslov skoka nije ispunjen 
	#nastavlja se sa izvrsavanjem instrukcija sekvencijalno 

	#posto uslov jge skoka nije bio ispunjen znamo da je tada rezultat
	#poredjenja bio manje (1.operand cmp instrukcije je manji od 2. operanda)
	jmp drugi_max

prvi_max:
	#vracamo vrednost 1. operanda (edi) kao maksimum
	mov eax, edi
	
	#zavrsavamo funkciju
	jmp kraj

drugi_max:
	#vracamo vrednost 2. operanda (esi) kao maksimum
	mov eax, esi

	#ovde nije neophodno da skacemo na labelu kraj 
	#jer se sekvencijalnim izvrsavanje instrukcija 
	#svakako nailazi na nju, tj. na instrukciju leave

kraj:
	leave
	ret

